/**
 * (C) 2011-2012 Alibaba Group Holding Limited.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 */
package com.taobao.common.tedis.core;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

/**
 * Hash
 *
 * @author juxin.zj E-mail:juxin.zj@taobao.com
 * @since 2011-7-25 11:54:26
 * @version 1.0
 */
public interface HashCommands {

    /**
     * ɾ<tt>key</tt>Hash<tt>hashKey</tt>
     *
     * @param namespace
     * @param key
     * @param hashKey
     */
    <H, HK, HV> void delete(int namespace, H key, Object... hashKey);

    /**
     * ж<tt>key</tt>Hash<tt>hashKey</tt>Ƿ
     *
     * @param namespace
     * @param key
     * @param hashKey
     * @return ڷ<tt>true</tt>ڷ<tt>false</tt>
     */
    <H, HK, HV> Boolean hasKey(int namespace, H key, Object hashKey);

    /**
     * ȡ<tt>key</tt>Hash<tt>hashKey</tt>
     *
     * @param namespace
     * @param key
     * @param hashKey
     * @return
     */
    <H, HK, HV> HV get(int namespace, H key, Object hashKey);

    /**
     * ȡ
     *
     * @param namespace
     * @param key
     * @param hashKeys
     * @return
     */
    <H, HK, HV> Collection<HV> multiGet(int namespace, H key, Collection<HK> hashKeys);

    /**
     *  <tt>delta</tt>Ϊ0ֵֵΪӼֵΪټ0Ϊȡõǰֵ
     *
     * @param namespace
     * @param key
     * @param hashKey
     * @param delta
     * @return
     */
    <H, HK, HV> Long increment(int namespace, H key, HK hashKey, long delta);

    /**
     * õ<tt>key</tt>Hashkey
     *
     * @param namespace
     * @param key
     * @return
     */
    <H, HK, HV> Set<HK> keys(int namespace, H key);

    /**
     * ȱ<tt>key</tt>HashĴС
     *
     * @param namespace
     * @param key
     * @return
     */
    <H, HK, HV> Long size(int namespace, H key);

    /**
     * 
     *
     * @param namespace
     * @param key
     * @param m
     */
    <H, HK, HV> void putAll(int namespace, H key, Map<? extends HK, ? extends HV> m);

    /**
     * ݣݴڣ򸲸ǣݲڣ
     *
     * @param namespace
     * @param key
     * @param hashKey
     * @param value
     */
    <H, HK, HV> void put(int namespace, H key, HK hashKey, HV value);

    /**
     * ݣֻݲڲóɹ
     *
     * @param namespace
     * @param key
     * @param hashKey
     * @param value
     * @return
     */
    <H, HK, HV> Boolean putIfAbsent(int namespace, H key, HK hashKey, HV value);

    /**
     * ȡ<tt>key</tt>Hashֵ
     *
     * @param namespace
     * @param key
     * @return
     */
    <H, HK, HV> Collection<HV> values(int namespace, H key);

    /**
     * ȱ<tt>key</tt>Hashkeyvalue
     *
     * @param namespace
     * @param key
     * @return
     */
    <H, HK, HV> Map<HK, HV> entries(int namespace, H key);

}
